Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 74219)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 74220)
@@ -1907,7 +1907,7 @@
 #
 ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),win.amd64)
-$(call VBOX_GENERATE_IMPORT_TARGET_FN,VBoxRTImp,VBoxRT,VBox/VBoxRTImp.def r3/win/VBoxRT-win64.def)
+$(call VBOX_GENERATE_IMPORT_TARGET_FN,VBoxRTImp,VBoxRT,VBox/VBoxRTImp.def VBox/VBoxRTImp-vcc64.def r3/win/VBoxRT-win64.def)
 else ifeq ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),win.x86)
-$(call VBOX_GENERATE_IMPORT_TARGET_FN,VBoxRTImp,VBoxRT,VBox/VBoxRTImp.def r3/win/VBoxRT-win32.def)
+$(call VBOX_GENERATE_IMPORT_TARGET_FN,VBoxRTImp,VBoxRT,VBox/VBoxRTImp.def VBox/VBoxRTImp-vcc32.def r3/win/VBoxRT-win32.def)
 else
 $(call VBOX_GENERATE_IMPORT_TARGET_FN,VBoxRTImp,VBoxRT,VBox/VBoxRTImp.def)
Index: trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc32.def
===================================================================
--- trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc32.def	(revision 74220)
+++ trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc32.def	(revision 74220)
@@ -0,0 +1,146 @@
+; $Id$
+;; @file
+; VirtualBox Runtime DLL - Stable C++ Interface Definition file, 32-bit Visual C++.
+
+;
+; Copyright (C) 2018 Oracle Corporation
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+EXPORTS
+    ; class RTCString:
+    ??0RTCString@@QAE@ABV0@@Z
+    ??0RTCString@@QAE@ABV0@II@Z
+    ??0RTCString@@QAE@ID@Z
+    ??0RTCString@@QAE@PBD@Z
+    ??0RTCString@@QAE@PBDI@Z
+    ??0RTCString@@QAE@PBDPAD@Z
+    ??0RTCString@@QAE@XZ
+    ??1RTCString@@UAE@XZ
+    ??4RTCString@@QAEAAV0@ABV0@@Z
+    ??4RTCString@@QAEAAV0@PBD@Z
+    ??8RTCString@@QBE_NABV0@@Z
+    ??8RTCString@@QBE_NPBD@Z
+    ??9RTCString@@QBE_NABV0@@Z
+    ??9RTCString@@QBE_NPBD@Z
+    ??ARTCString@@QBEDI@Z
+    ??MRTCString@@QBE_NABV0@@Z
+    ??MRTCString@@QBE_NPBD@Z
+    ??ORTCString@@QBE_NABV0@@Z
+    ??ORTCString@@QBE_NPBD@Z
+    ??YRTCString@@QAEAAV0@ABV0@@Z
+    ??YRTCString@@QAEAAV0@D@Z
+    ??YRTCString@@QAEAAV0@PBD@Z
+    ??_7RTCString@@6B@
+    ?append@RTCString@@QAEAAV1@ABV1@@Z
+    ?append@RTCString@@QAEAAV1@ABV1@II@Z
+    ?append@RTCString@@QAEAAV1@D@Z
+    ?append@RTCString@@QAEAAV1@PBD@Z
+    ?append@RTCString@@QAEAAV1@PBDI@Z
+    ?appendCodePoint@RTCString@@QAEAAV1@I@Z
+    ?appendCodePointNoThrow@RTCString@@QAEHI@Z
+    ?appendNoThrow@RTCString@@QAEHABV1@@Z
+    ?appendNoThrow@RTCString@@QAEHABV1@II@Z
+    ?appendNoThrow@RTCString@@QAEHD@Z
+    ?appendNoThrow@RTCString@@QAEHPBD@Z
+    ?appendNoThrow@RTCString@@QAEHPBDI@Z
+    ?appendPrintf@RTCString@@QAAAAV1@PBDZZ
+    ?appendPrintfNoThrow@RTCString@@QAAHPBDZZ
+    ?appendPrintfV@RTCString@@QAEAAV1@PBDPAD@Z
+    ?appendPrintfVNoThrow@RTCString@@QAEHPBDPAD@Z
+    ?appendWorker@RTCString@@IAEAAV1@PBDI@Z
+    ?appendWorkerNoThrow@RTCString@@IAEHPBDI@Z
+    ?assign@RTCString@@QAEAAV1@ABV1@@Z
+    ?assign@RTCString@@QAEAAV1@ABV1@II@Z
+    ?assign@RTCString@@QAEAAV1@ID@Z
+    ?assign@RTCString@@QAEAAV1@PBD@Z
+    ?assign@RTCString@@QAEAAV1@PBDI@Z
+    ?assignNoThrow@RTCString@@QAEHABV1@@Z
+    ?assignNoThrow@RTCString@@QAEHABV1@II@Z
+    ?assignNoThrow@RTCString@@QAEHID@Z
+    ?assignNoThrow@RTCString@@QAEHPBD@Z
+    ?assignNoThrow@RTCString@@QAEHPBDI@Z
+    ?c_str@RTCString@@QBEPBDXZ
+    ?capacity@RTCString@@QBEIXZ
+    ?cleanup@RTCString@@IAEXXZ
+    ?compare@RTCString@@QBEHABV1@W4CaseSensitivity@1@@Z
+    ?compare@RTCString@@QBEHPBDW4CaseSensitivity@1@@Z
+    ?contains@RTCString@@QBE_NABV1@W4CaseSensitivity@1@@Z
+    ?contains@RTCString@@QBE_NPBDW4CaseSensitivity@1@@Z
+    ?copyFromN@RTCString@@IAEXPBDI@Z
+    ?count@RTCString@@QBEID@Z
+    ?endsWith@RTCString@@QBE_NABV1@W4CaseSensitivity@1@@Z
+    ?equals@RTCString@@QBE_NABV1@@Z
+    ?equals@RTCString@@QBE_NPBD@Z
+    ?equalsIgnoreCase@RTCString@@QBE_NABV1@@Z
+    ?equalsIgnoreCase@RTCString@@QBE_NPBD@Z
+    ?erase@RTCString@@QAEAAV1@II@Z
+    ?find@RTCString@@QBEIPBDI@Z
+    ?find@RTCString@@QBEIPBV1@I@Z
+    ?findReplace@RTCString@@QAEXDD@Z
+    ?isEmpty@RTCString@@QBE_NXZ
+    ?isNotEmpty@RTCString@@QBE_NXZ
+    ?join@RTCString@@SA?AV1@ABV?$RTCList@VRTCString@@PAV1@@@ABV1@@Z
+    ?joinEx@RTCString@@SA?AV1@ABV?$RTCList@VRTCString@@PAV1@@@ABV1@1@Z
+    ?jolt@RTCString@@QAEXXZ
+    ?length@RTCString@@QBEIXZ
+    ?mutableRaw@RTCString@@QAEPADXZ
+    ?npos@RTCString@@2IB
+    ?printf@RTCString@@QAAAAV1@PBDZZ
+    ?printfNoThrow@RTCString@@QAAHPBDZZ
+    ?printfOutputCallback@RTCString@@KAIPAXPBDI@Z
+    ?printfOutputCallbackNoThrow@RTCString@@KAIPAXPBDI@Z
+    ?printfV@RTCString@@QAEAAV1@PBDPAD@Z
+    ?printfVNoThrow@RTCString@@QAEHPBDPAD@Z
+    ?replace@RTCString@@QAEAAV1@IIABV1@@Z
+    ?replace@RTCString@@QAEAAV1@IIABV1@II@Z
+    ?replace@RTCString@@QAEAAV1@IIPBD@Z
+    ?replace@RTCString@@QAEAAV1@IIPBDI@Z
+    ?replaceNoThrow@RTCString@@QAEHIIABV1@@Z
+    ?replaceNoThrow@RTCString@@QAEHIIABV1@II@Z
+    ?replaceNoThrow@RTCString@@QAEHIIPBD@Z
+    ?replaceNoThrow@RTCString@@QAEHIIPBDI@Z
+    ?replaceWorker@RTCString@@IAEAAV1@IIPBDI@Z
+    ?replaceWorkerNoThrow@RTCString@@IAEHIIPBDI@Z
+    ?reserve@RTCString@@QAEXI@Z
+    ?reserveNoThrow@RTCString@@QAEHI@Z
+    ?setNull@RTCString@@QAEXXZ
+    ?split@RTCString@@QBE?AV?$RTCList@VRTCString@@PAV1@@@ABV1@W4SplitMode@1@@Z
+    ?startsWith@RTCString@@QBE_NABV1@W4CaseSensitivity@1@@Z
+    ?startsWithWord@RTCString@@QBE_NABV1@W4CaseSensitivity@1@@Z
+    ?startsWithWord@RTCString@@QBE_NPBDW4CaseSensitivity@1@@Z
+    ?strip@RTCString@@QAEAAV1@XZ
+    ?stripLeft@RTCString@@QAEAAV1@XZ
+    ?stripRight@RTCString@@QAEAAV1@XZ
+    ?substr@RTCString@@QBE?AV1@II@Z
+    ?substrCP@RTCString@@QBE?AV1@II@Z
+    ?swap@RTCString@@QAEXAAV1@@Z
+    ?toInt32@RTCString@@QBEHXZ
+    ?toInt64@RTCString@@QBE_JXZ
+    ?toInt@RTCString@@QBEHAAI@Z
+    ?toInt@RTCString@@QBEHAA_K@Z
+    ?toLower@RTCString@@QAEAAV1@XZ
+    ?toUInt32@RTCString@@QBEIXZ
+    ?toUInt64@RTCString@@QBE_KXZ
+    ?toUpper@RTCString@@QAEAAV1@XZ
+    ?uniLength@RTCString@@QBEIXZ
+    ; Related to RTCString:
+    ??H@YA?BVRTCString@@ABV0@0@Z
+    ??H@YA?BVRTCString@@ABV0@PBD@Z
+    ??H@YA?BVRTCString@@PBDABV0@@Z
+
Index: trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc64.def
===================================================================
--- trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc64.def	(revision 74220)
+++ trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc64.def	(revision 74220)
@@ -0,0 +1,146 @@
+; $Id$
+;; @file
+; VirtualBox Runtime DLL - Stable C++ Interface Definition file, 32-bit Visual C++.
+
+;
+; Copyright (C) 2018 Oracle Corporation
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+EXPORTS
+    ; class RTCString:
+    ??0RTCString@@QEAA@AEBV0@@Z
+    ??0RTCString@@QEAA@AEBV0@_K1@Z
+    ??0RTCString@@QEAA@PEBD@Z
+    ??0RTCString@@QEAA@PEBDPEAD@Z
+    ??0RTCString@@QEAA@PEBD_K@Z
+    ??0RTCString@@QEAA@XZ
+    ??0RTCString@@QEAA@_KD@Z
+    ??1RTCString@@UEAA@XZ
+    ??4RTCString@@QEAAAEAV0@AEBV0@@Z
+    ??4RTCString@@QEAAAEAV0@PEBD@Z
+    ??8RTCString@@QEBA_NAEBV0@@Z
+    ??8RTCString@@QEBA_NPEBD@Z
+    ??9RTCString@@QEBA_NAEBV0@@Z
+    ??9RTCString@@QEBA_NPEBD@Z
+    ??ARTCString@@QEBAD_K@Z
+    ??MRTCString@@QEBA_NAEBV0@@Z
+    ??MRTCString@@QEBA_NPEBD@Z
+    ??ORTCString@@QEBA_NAEBV0@@Z
+    ??ORTCString@@QEBA_NPEBD@Z
+    ??YRTCString@@QEAAAEAV0@AEBV0@@Z
+    ??YRTCString@@QEAAAEAV0@D@Z
+    ??YRTCString@@QEAAAEAV0@PEBD@Z
+    ??_7RTCString@@6B@
+    ?append@RTCString@@QEAAAEAV1@AEBV1@@Z
+    ?append@RTCString@@QEAAAEAV1@AEBV1@_K1@Z
+    ?append@RTCString@@QEAAAEAV1@D@Z
+    ?append@RTCString@@QEAAAEAV1@PEBD@Z
+    ?append@RTCString@@QEAAAEAV1@PEBD_K@Z
+    ?appendCodePoint@RTCString@@QEAAAEAV1@I@Z
+    ?appendCodePointNoThrow@RTCString@@QEAAHI@Z
+    ?appendNoThrow@RTCString@@QEAAHAEBV1@@Z
+    ?appendNoThrow@RTCString@@QEAAHAEBV1@_K1@Z
+    ?appendNoThrow@RTCString@@QEAAHD@Z
+    ?appendNoThrow@RTCString@@QEAAHPEBD@Z
+    ?appendNoThrow@RTCString@@QEAAHPEBD_K@Z
+    ?appendPrintf@RTCString@@QEAAAEAV1@PEBDZZ
+    ?appendPrintfNoThrow@RTCString@@QEAAHPEBDZZ
+    ?appendPrintfV@RTCString@@QEAAAEAV1@PEBDPEAD@Z
+    ?appendPrintfVNoThrow@RTCString@@QEAAHPEBDPEAD@Z
+    ?appendWorker@RTCString@@IEAAAEAV1@PEBD_K@Z
+    ?appendWorkerNoThrow@RTCString@@IEAAHPEBD_K@Z
+    ?assign@RTCString@@QEAAAEAV1@AEBV1@@Z
+    ?assign@RTCString@@QEAAAEAV1@AEBV1@_K1@Z
+    ?assign@RTCString@@QEAAAEAV1@PEBD@Z
+    ?assign@RTCString@@QEAAAEAV1@PEBD_K@Z
+    ?assign@RTCString@@QEAAAEAV1@_KD@Z
+    ?assignNoThrow@RTCString@@QEAAHAEBV1@@Z
+    ?assignNoThrow@RTCString@@QEAAHAEBV1@_K1@Z
+    ?assignNoThrow@RTCString@@QEAAHPEBD@Z
+    ?assignNoThrow@RTCString@@QEAAHPEBD_K@Z
+    ?assignNoThrow@RTCString@@QEAAH_KD@Z
+    ?c_str@RTCString@@QEBAPEBDXZ
+    ?capacity@RTCString@@QEBA_KXZ
+    ?cleanup@RTCString@@IEAAXXZ
+    ?compare@RTCString@@QEBAHAEBV1@W4CaseSensitivity@1@@Z
+    ?compare@RTCString@@QEBAHPEBDW4CaseSensitivity@1@@Z
+    ?contains@RTCString@@QEBA_NAEBV1@W4CaseSensitivity@1@@Z
+    ?contains@RTCString@@QEBA_NPEBDW4CaseSensitivity@1@@Z
+    ?copyFromN@RTCString@@IEAAXPEBD_K@Z
+    ?count@RTCString@@QEBA_KD@Z
+    ?endsWith@RTCString@@QEBA_NAEBV1@W4CaseSensitivity@1@@Z
+    ?equals@RTCString@@QEBA_NAEBV1@@Z
+    ?equals@RTCString@@QEBA_NPEBD@Z
+    ?equalsIgnoreCase@RTCString@@QEBA_NAEBV1@@Z
+    ?equalsIgnoreCase@RTCString@@QEBA_NPEBD@Z
+    ?erase@RTCString@@QEAAAEAV1@_K0@Z
+    ?find@RTCString@@QEBA_KPEBD_K@Z
+    ?find@RTCString@@QEBA_KPEBV1@_K@Z
+    ?findReplace@RTCString@@QEAAXDD@Z
+    ?isEmpty@RTCString@@QEBA_NXZ
+    ?isNotEmpty@RTCString@@QEBA_NXZ
+    ?join@RTCString@@SA?AV1@AEBV?$RTCList@VRTCString@@PEAV1@@@AEBV1@@Z
+    ?joinEx@RTCString@@SA?AV1@AEBV?$RTCList@VRTCString@@PEAV1@@@AEBV1@1@Z
+    ?jolt@RTCString@@QEAAXXZ
+    ?length@RTCString@@QEBA_KXZ
+    ?mutableRaw@RTCString@@QEAAPEADXZ
+    ?npos@RTCString@@2_KB
+    ?printf@RTCString@@QEAAAEAV1@PEBDZZ
+    ?printfNoThrow@RTCString@@QEAAHPEBDZZ
+    ?printfOutputCallback@RTCString@@KA_KPEAXPEBD_K@Z
+    ?printfOutputCallbackNoThrow@RTCString@@KA_KPEAXPEBD_K@Z
+    ?printfV@RTCString@@QEAAAEAV1@PEBDPEAD@Z
+    ?printfVNoThrow@RTCString@@QEAAHPEBDPEAD@Z
+    ?replace@RTCString@@QEAAAEAV1@_K0AEBV1@00@Z
+    ?replace@RTCString@@QEAAAEAV1@_K0AEBV1@@Z
+    ?replace@RTCString@@QEAAAEAV1@_K0PEBD0@Z
+    ?replace@RTCString@@QEAAAEAV1@_K0PEBD@Z
+    ?replaceNoThrow@RTCString@@QEAAH_K0AEBV1@00@Z
+    ?replaceNoThrow@RTCString@@QEAAH_K0AEBV1@@Z
+    ?replaceNoThrow@RTCString@@QEAAH_K0PEBD0@Z
+    ?replaceNoThrow@RTCString@@QEAAH_K0PEBD@Z
+    ?replaceWorker@RTCString@@IEAAAEAV1@_K0PEBD0@Z
+    ?replaceWorkerNoThrow@RTCString@@IEAAH_K0PEBD0@Z
+    ?reserve@RTCString@@QEAAX_K@Z
+    ?reserveNoThrow@RTCString@@QEAAH_K@Z
+    ?setNull@RTCString@@QEAAXXZ
+    ?split@RTCString@@QEBA?AV?$RTCList@VRTCString@@PEAV1@@@AEBV1@W4SplitMode@1@@Z
+    ?startsWith@RTCString@@QEBA_NAEBV1@W4CaseSensitivity@1@@Z
+    ?startsWithWord@RTCString@@QEBA_NAEBV1@W4CaseSensitivity@1@@Z
+    ?startsWithWord@RTCString@@QEBA_NPEBDW4CaseSensitivity@1@@Z
+    ?strip@RTCString@@QEAAAEAV1@XZ
+    ?stripLeft@RTCString@@QEAAAEAV1@XZ
+    ?stripRight@RTCString@@QEAAAEAV1@XZ
+    ?substr@RTCString@@QEBA?AV1@_K0@Z
+    ?substrCP@RTCString@@QEBA?AV1@_K0@Z
+    ?swap@RTCString@@QEAAXAEAV1@@Z
+    ?toInt32@RTCString@@QEBAHXZ
+    ?toInt64@RTCString@@QEBA_JXZ
+    ?toInt@RTCString@@QEBAHAEAI@Z
+    ?toInt@RTCString@@QEBAHAEA_K@Z
+    ?toLower@RTCString@@QEAAAEAV1@XZ
+    ?toUInt32@RTCString@@QEBAIXZ
+    ?toUInt64@RTCString@@QEBA_KXZ
+    ?toUpper@RTCString@@QEAAAEAV1@XZ
+    ?uniLength@RTCString@@QEBA_KXZ
+    ; Related to RTCString:
+    ??H@YA?BVRTCString@@AEBV0@0@Z
+    ??H@YA?BVRTCString@@AEBV0@PEBD@Z
+    ??H@YA?BVRTCString@@PEBDAEBV0@@Z
+
Index: trunk/src/VBox/Runtime/VBox/VBoxRTImp.def
===================================================================
--- trunk/src/VBox/Runtime/VBox/VBoxRTImp.def	(revision 74219)
+++ trunk/src/VBox/Runtime/VBox/VBoxRTImp.def	(revision 74220)
@@ -253,7 +253,11 @@
     RTAvlrooGCPtrRemove
     RTBase64Decode
+    RTBase64DecodeEx
     RTBase64DecodedSize
+    RTBase64DecodedSizeEx
     RTBase64Encode
+    RTBase64EncodeEx
     RTBase64EncodedLength
+    RTBase64EncodedLengthEx
     RTBldCfgCompiler
     RTBldCfgRevision
@@ -299,7 +303,75 @@
     RTCritSectLeave
     RTCritSectLeaveMultiple
+    RTCritSectRwDelete
+    RTCritSectRwEnterExcl
+    RTCritSectRwEnterExclDebug
+    RTCritSectRwEnterShared
+    RTCritSectRwEnterSharedDebug
+    RTCritSectRwGetReadCount
+    RTCritSectRwGetWriteRecursion
+    RTCritSectRwGetWriterReadRecursion
+    RTCritSectRwInit
+    RTCritSectRwInitEx
+    RTCritSectRwIsReadOwner
+    RTCritSectRwIsWriteOwner
+    RTCritSectRwLeaveExcl
+    RTCritSectRwLeaveShared
+    RTCritSectRwSetSubClass
+    RTCritSectRwTryEnterExcl
+    RTCritSectRwTryEnterExclDebug
+    RTCritSectRwTryEnterShared
+    RTCritSectRwTryEnterSharedDebug
     RTCritSectSetSubClass
     RTCritSectTryEnter
     RTCritSectTryEnterDebug
+    RTCrDigestClone
+    RTCrDigestCreate
+    RTCrDigestCreateByObjId
+    RTCrDigestCreateByObjIdString
+    RTCrDigestCreateByType
+    RTCrDigestFinal
+    RTCrDigestFindByObjId
+    RTCrDigestFindByObjIdString
+    RTCrDigestFindByType
+    RTCrDigestGetAlgorithmOid
+    RTCrDigestGetConsumedSize
+    RTCrDigestGetFlags
+    RTCrDigestGetHash
+    RTCrDigestGetHashSize
+    RTCrDigestGetType
+    RTCrDigestIsFinalized
+    RTCrDigestMatch
+    RTCrDigestRelease
+    RTCrDigestReset
+    RTCrDigestRetain
+    RTCrDigestTypeToAlgorithmOid
+    RTCrDigestTypeToHashSize
+    RTCrDigestTypeToName
+    RTCrDigestUpdate
+    RTCrDigestUpdateFromVfsFile
+    RTCrKeyCreateFromBuffer
+    RTCrKeyCreateFromFile
+    RTCrKeyCreateFromPublicAlgorithmAndBits
+    RTCrKeyCreateFromSubjectPublicKeyInfo
+    RTCrKeyGetBitCount
+    RTCrKeyGetType
+    RTCrKeyHasPrivatePart
+    RTCrKeyHasPublicPart
+    RTCrKeyRelease
+    RTCrKeyRetain
+    RTCrPkixGetCiperOidFromSignatureAlgorithm
+    RTCrPkixPubKeySignDigest
+    RTCrPkixPubKeyVerifySignature
+    RTCrPkixPubKeyVerifySignedDigest
+    RTCrPkixPubKeyVerifySignedDigestByCertPubKeyInfo
+    RTCrPkixSignatureCreate
+    RTCrPkixSignatureCreateByObjId
+    RTCrPkixSignatureCreateByObjIdString
+    RTCrPkixSignatureRelease
+    RTCrPkixSignatureRetain
+    RTCrPkixSignatureSign
+    RTCrPkixSignatureVerify
+    RTCrPkixSignatureVerifyBitString
+    RTCrPkixSignatureVerifyOctetString
     RTDbgAsCreate
     RTDbgAsCreateF
@@ -504,8 +576,59 @@
     RTHeapSimpleRelocate
     RTHeapSimpleSize
-    RTIsoFsClose
-    RTIsoFsExtractFile
-    RTIsoFsGetFileInfo
-    RTIsoFsOpen
+    RTHttpAbort
+    RTHttpAddHeader
+    RTHttpCreate
+    RTHttpDestroy
+    RTHttpFreeResponse
+    RTHttpFreeResponseText
+    RTHttpGatherCaCertsInFile
+    RTHttpGatherCaCertsInStore
+    RTHttpGetBinary
+    RTHttpGetByOrdinal
+    RTHttpGetFile
+    RTHttpGetHeader
+    RTHttpGetHeaderBinary
+    RTHttpGetHeaderCount
+    RTHttpGetHeaderText
+    RTHttpGetRedirLocation
+    RTHttpGetText
+    RTHttpMethodName
+    RTHttpPerform
+    RTHttpReset
+    RTHttpSetCAFile
+    RTHttpSetDownloadCallback
+    RTHttpSetDownloadProgressCallback
+    RTHttpSetFollowRedirects
+    RTHttpSetHeaders
+    RTHttpSetProxy
+    RTHttpSetUploadCallback
+    RTHttpSignHeaders
+    RTHttpUseSystemProxySettings
+    RTHttpUseTemporaryCaFile
+    RTJsonIteratorBegin
+    RTJsonIteratorBeginArray
+    RTJsonIteratorBeginObject
+    RTJsonIteratorFree
+    RTJsonIteratorNext
+    RTJsonIteratorQueryValue
+    RTJsonParseFromBuf
+    RTJsonParseFromFile
+    RTJsonParseFromString
+    RTJsonValueGetArraySize
+    RTJsonValueGetString
+    RTJsonValueGetType
+    RTJsonValueQueryArraySize
+    RTJsonValueQueryBooleanByName
+    RTJsonValueQueryByIndex
+    RTJsonValueQueryByName
+    RTJsonValueQueryInteger
+    RTJsonValueQueryIntegerByName
+    RTJsonValueQueryNumber
+    RTJsonValueQueryNumberByName
+    RTJsonValueQueryString
+    RTJsonValueQueryStringByName
+    RTJsonValueRelease
+    RTJsonValueRetain
+    RTJsonValueTypeName
     RTLatin1CalcUtf16Len
     RTLatin1CalcUtf16LenEx
@@ -920,16 +1043,4 @@
     RTReqSubmit
     RTReqWait
-    RTS3BucketsDestroy
-    RTS3Create
-    RTS3CreateBucket
-    RTS3DeleteBucket
-    RTS3DeleteKey
-    RTS3Destroy
-    RTS3GetBucketKeys
-    RTS3GetBuckets
-    RTS3GetKey
-    RTS3KeysDestroy
-    RTS3PutKey
-    RTS3SetProgressCallback
     RTSemEventAddSignaller
     RTSemEventCreate
@@ -1073,5 +1184,9 @@
     RTStrCacheDestroy
     RTStrCacheEnter
+    RTStrCacheEnterLower
+    RTStrCacheEnterLowerN
     RTStrCacheEnterN
+    RTStrCacheGetStats
+    RTStrCacheIsRealImpl
     RTStrCacheLength
     RTStrCacheRelease
@@ -1083,8 +1198,12 @@
     RTStrCat
     RTStrCatEx
+    RTStrCatP
+    RTStrCatPEx
     RTStrCmp
     RTStrConvertHexBytes
     RTStrCopy
     RTStrCopyEx
+    RTStrCopyP
+    RTStrCopyPEx
     RTStrCurrentCPToUtf8Tag
     RTStrDupExTag
@@ -1093,7 +1212,16 @@
     RTStrFormat
     RTStrFormatNumber
+    RTStrFormatR80
+    RTStrFormatR80u2
     RTStrFormatTypeDeregister
     RTStrFormatTypeRegister
     RTStrFormatTypeSetUser
+    RTStrFormatU128
+    RTStrFormatU16
+    RTStrFormatU256
+    RTStrFormatU32
+    RTStrFormatU512
+    RTStrFormatU64
+    RTStrFormatU8
     RTStrFormatV
     RTStrFree
@@ -1101,9 +1229,19 @@
     RTStrGetCpInternal
     RTStrGetCpNExInternal
+    RTStrHash1
+    RTStrHash1ExN
+    RTStrHash1ExNV
+    RTStrHash1N
     RTStrICmp
+    RTStrICmpAscii
+    RTStrIStartsWith
     RTStrIStr
+    RTStrIsCaseFoldable
+    RTStrIsLowerCased
+    RTStrIsUpperCased
     RTStrIsValidEncoding
     RTStrNCmp
     RTStrNICmp
+    RTStrNICmpAscii
     RTStrNLen
     RTStrNLenEx
@@ -1111,7 +1249,12 @@
     RTStrPrintHexBytes
     RTStrPrintf
+    RTStrPrintf2
+    RTStrPrintf2Ex
+    RTStrPrintf2ExV
+    RTStrPrintf2V
     RTStrPrintfEx
     RTStrPrintfExV
     RTStrPrintfV
+    RTStrPurgeComplementSet
     RTStrPurgeEncoding
     RTStrPutCpInternal
@@ -1123,6 +1266,8 @@
     RTStrSpaceEnumerate
     RTStrSpaceGet
+    RTStrSpaceGetN
     RTStrSpaceInsert
     RTStrSpaceRemove
+    RTStrStartsWith
     RTStrStr
     RTStrStrip
@@ -1159,4 +1304,6 @@
     RTStrToUniEx
     RTStrToUpper
+    RTStrToUtf16BigExTag
+    RTStrToUtf16BigTag
     RTStrToUtf16ExTag
     RTStrToUtf16Tag
@@ -1428,12 +1575,42 @@
     RTVfsChainOpenIoStream
     RTVfsChainSpecFree
+    RTVfsDirCreateDir
+    RTVfsDirFromRTDir
+    RTVfsDirOpen
+    RTVfsDirOpenDir
+    RTVfsDirOpenFile
+    RTVfsDirOpenFileAsIoStream
+    RTVfsDirOpenNormal
+    RTVfsDirOpenObj
+    RTVfsDirQueryPathInfo
+    RTVfsDirReadEx
     RTVfsDirRelease
+    RTVfsDirRemoveDir
     RTVfsDirRetain
+    RTVfsDirRetainDebug
+    RTVfsFileFlush
+    RTVfsFileFromBuffer
     RTVfsFileFromRTFile
+    RTVfsFileGetMaxSize
+    RTVfsFileGetOpenFlags
+    RTVfsFileGetSize
     RTVfsFileOpen
+    RTVfsFileOpenNormal
+    RTVfsFilePoll
+    RTVfsFileQueryInfo
+    RTVfsFileQueryMaxSize
+    RTVfsFileRead
+    RTVfsFileReadAt
     RTVfsFileRelease
     RTVfsFileRetain
+    RTVfsFileRetainDebug
     RTVfsFileSeek
+    RTVfsFileSetSize
+    RTVfsFileSgRead
+    RTVfsFileSgWrite
+    RTVfsFileTell
     RTVfsFileToIoStream
+    RTVfsFileWrite
+    RTVfsFileWriteAt
     RTVfsFsStrmNext
     RTVfsFsStrmQueryInfo
@@ -1442,12 +1619,20 @@
     RTVfsIoStreamToPrivate
     RTVfsIoStrmFlush
+    RTVfsIoStrmFromBuffer
     RTVfsIoStrmFromRTFile
+    RTVfsIoStrmFromRTPipe
     RTVfsIoStrmFromStdHandle
+    RTVfsIoStrmGetOpenFlags
     RTVfsIoStrmIsAtEnd
+    RTVfsIoStrmOpenNormal
     RTVfsIoStrmPoll
     RTVfsIoStrmQueryInfo
     RTVfsIoStrmRead
+    RTVfsIoStrmReadAll
+    RTVfsIoStrmReadAllFree
+    RTVfsIoStrmReadAt
     RTVfsIoStrmRelease
     RTVfsIoStrmRetain
+    RTVfsIoStrmRetainDebug
     RTVfsIoStrmSgRead
     RTVfsIoStrmSgWrite
@@ -1455,5 +1640,7 @@
     RTVfsIoStrmTell
     RTVfsIoStrmToFile
+    RTVfsIoStrmValidateUtf8Encoding
     RTVfsIoStrmWrite
+    RTVfsIoStrmWriteAt
     RTVfsIoStrmZeroFill
     RTVfsLockAcquireReadSlow
@@ -1525,2 +1712,20 @@
     SUPR3TracerIoCtl
 
+    ; Very temporary stuff:
+    RTHttpRawGetResponseCode
+    RTHttpRawPerform
+    RTHttpRawSetCustomRequest
+    RTHttpRawSetDelete
+    RTHttpRawSetGet
+    RTHttpRawSetHead
+    RTHttpRawSetInfileSize
+    RTHttpRawSetPost
+    RTHttpRawSetPostFields
+    RTHttpRawSetPut
+    RTHttpRawSetReadCallback
+    RTHttpRawSetTimeout
+    RTHttpRawSetUrl
+    RTHttpRawSetVerbose
+    RTHttpRawSetWriteCallback
+    RTHttpRawSetWriteHeaderCallback
+