Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 74319)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 74320)
@@ -2144,10 +2144,4 @@
     actionPool()->action(UIActionIndexST_M_Machine_T_Pause)->retranslateUi();
     actionPool()->action(UIActionIndexST_M_Machine_T_Pause)->blockSignals(false);
-
-    /* Enable/disable tools actions: */
-    actionPool()->action(UIActionIndexST_M_Tools_M_Machine)->setEnabled(isActionEnabled(UIActionIndexST_M_Tools_M_Machine, items));
-    actionPool()->action(UIActionIndexST_M_Tools_M_Machine_S_Details)->setEnabled(isActionEnabled(UIActionIndexST_M_Tools_M_Machine_S_Details, items));
-    actionPool()->action(UIActionIndexST_M_Tools_M_Machine_S_Snapshots)->setEnabled(isActionEnabled(UIActionIndexST_M_Tools_M_Machine_S_Snapshots, items));
-    actionPool()->action(UIActionIndexST_M_Tools_M_Machine_S_LogViewer)->setEnabled(isActionEnabled(UIActionIndexST_M_Tools_M_Machine_S_LogViewer, items));
 }
 
@@ -2276,11 +2270,4 @@
         {
             return isActionEnabled(UIActionIndexST_M_Machine_M_Close, items);
-        }
-        case UIActionIndexST_M_Tools_M_Machine:
-        case UIActionIndexST_M_Tools_M_Machine_S_Details:
-        case UIActionIndexST_M_Tools_M_Machine_S_Snapshots:
-        case UIActionIndexST_M_Tools_M_Machine_S_LogViewer:
-        {
-            return pItem->accessible();
         }
         default:
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 74319)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 74320)
@@ -219,7 +219,9 @@
         && m_pStackedWidget->currentWidget() != m_pPaneToolsGlobal)
     {
+        /* Just start animation and return, do nothing else.. */
         m_pStackedWidget->setCurrentWidget(m_pPaneToolsGlobal); // rendering w/a
         m_pStackedWidget->setCurrentWidget(m_pSlidingAnimation);
         m_pSlidingAnimation->animate(SlidingDirection_Reverse);
+        return;
     }
 
@@ -228,9 +230,11 @@
     /* If machine or group item is selected and we are on global tools pane => switch to machine tools pane: */
     if (   (isMachineItemSelected() || isGroupItemSelected())
-        && m_pStackedWidget->currentWidget() != m_pPaneToolsMachine)
-    {
+             && m_pStackedWidget->currentWidget() != m_pPaneToolsMachine)
+    {
+        /* Just start animation and return, do nothing else.. */
         m_pStackedWidget->setCurrentWidget(m_pPaneToolsMachine); // rendering w/a
         m_pStackedWidget->setCurrentWidget(m_pSlidingAnimation);
         m_pSlidingAnimation->animate(SlidingDirection_Forward);
+        return;
     }
 
@@ -255,11 +259,11 @@
                 /* Make sure Details or Snapshot pane is chosen if opened: */
                 if (m_pPaneToolsMachine->isToolOpened(ToolTypeMachine_Details))
-                    actionPool()->action(UIActionIndexST_M_Tools_M_Machine_S_Details)->trigger();
+                    switchToTool(ToolTypeMachine_Details);
                 else
                 if (m_pPaneToolsMachine->isToolOpened(ToolTypeMachine_Snapshots))
-                    actionPool()->action(UIActionIndexST_M_Tools_M_Machine_S_Snapshots)->trigger();
+                    switchToTool(ToolTypeMachine_Snapshots);
                 else
                 if (m_pPaneToolsMachine->isToolOpened(ToolTypeMachine_LogViewer))
-                    actionPool()->action(UIActionIndexST_M_Tools_M_Machine_S_LogViewer)->trigger();
+                    switchToTool(ToolTypeMachine_LogViewer);
             }
 
@@ -296,4 +300,5 @@
 void UIVirtualBoxManagerWidget::sltHandleSlidingAnimationComplete(SlidingDirection enmDirection)
 {
+    /* First switch the panes: */
     switch (enmDirection)
     {
@@ -311,4 +316,6 @@
         }
     }
+    /* Then handle current item change (again!): */
+    sltHandleChooserPaneIndexChangeDefault();
 }
 