Index: trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc32.def
===================================================================
--- trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc32.def	(revision 74426)
+++ trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc32.def	(revision 74427)
@@ -326,8 +326,10 @@
     ?containsKey@RTCRestStringMapBase@@QBE_NABVRTCString@@@Z                    ; (public: bool __thiscall RTCRestStringMapBase::containsKey(class RTCString const &)const )
     ?containsKey@RTCRestStringMapBase@@QBE_NPBD@Z                               ; (public: bool __thiscall RTCRestStringMapBase::containsKey(char const *)const )
-    ?copyArrayWorker@RTCRestArrayBase@@IAEHABV1@_N@Z                            ; (protected: int __thiscall RTCRestArrayBase::copyArrayWorker(class RTCRestArrayBase const &,bool))
+    ?copyArrayWorkerMayThrow@RTCRestArrayBase@@IAEXABV1@@Z                      ; (protected: void __thiscall RTCRestArrayBase::copyArrayWorkerMayThrow(class RTCRestArrayBase const &))
+    ?copyArrayWorkerNoThrow@RTCRestArrayBase@@IAEHABV1@@Z                       ; (protected: int __thiscall RTCRestArrayBase::copyArrayWorkerNoThrow(class RTCRestArrayBase const &))
     ?copyErrInfo@RTCRestClientResponseBase@@IAEXPBURTERRINFO@@@Z                ; (protected: void __thiscall RTCRestClientResponseBase::copyErrInfo(struct RTERRINFO const *))
     ?copyFromN@RTCString@@IAEXPBDI@Z                                            ; (protected: void __thiscall RTCString::copyFromN(char const *,unsigned int))
-    ?copyMapWorker@RTCRestStringMapBase@@IAEHABV1@_N@Z                          ; (protected: int __thiscall RTCRestStringMapBase::copyMapWorker(class RTCRestStringMapBase const &,bool))
+    ?copyMapWorkerMayThrow@RTCRestStringMapBase@@IAEXABV1@@Z                    ; (protected: void __thiscall RTCRestStringMapBase::copyMapWorkerMayThrow(class RTCRestStringMapBase const &))
+    ?copyMapWorkerNoThrow@RTCRestStringMapBase@@IAEHABV1@@Z                     ; (protected: int __thiscall RTCRestStringMapBase::copyMapWorkerNoThrow(class RTCRestStringMapBase const &))
     ?count@RTCString@@QBEID@Z                                                   ; (public: unsigned int __thiscall RTCString::count(char)const )
     ?createInstance@RTCRestAnyObject@@SAPAVRTCRestObjectBase@@XZ                ; (public: static class RTCRestObjectBase * __cdecl RTCRestAnyObject::createInstance(void))
@@ -426,10 +428,10 @@
     ?getExploded@RTCRestDate@@QBEABURTTIME@@XZ                                  ; (public: struct RTTIME const & __thiscall RTCRestDate::getExploded(void)const )
     ?getFormat@RTCRestDate@@QBE?AW4kFormat@1@XZ                                 ; (public: enum RTCRestDate::kFormat __thiscall RTCRestDate::getFormat(void)const )
-    ?getHttpStatus@RTCRestClientResponseBase@@QAEHXZ                            ; (public: int __thiscall RTCRestClientResponseBase::getHttpStatus(void))
+    ?getHttpStatus@RTCRestClientResponseBase@@QBEHXZ                            ; (public: int __thiscall RTCRestClientResponseBase::getHttpStatus(void)const )
     ?getPath@RTCRestJsonPrimaryCursor@@UBEPADABURTCRestJsonCursor@@PADI@Z       ; (public: virtual char * __thiscall RTCRestJsonPrimaryCursor::getPath(struct RTCRestJsonCursor const &,char *,unsigned int)const )
     ?getPtr@RTCRestBinary@@QBEPBEXZ                                             ; (public: unsigned char const * __thiscall RTCRestBinary::getPtr(void)const )
     ?getServerUrl@RTCRestClientApiBase@@QBEPBDXZ                                ; (public: char const * __thiscall RTCRestClientApiBase::getServerUrl(void)const )
     ?getSize@RTCRestBinary@@QBEIXZ                                              ; (public: unsigned int __thiscall RTCRestBinary::getSize(void)const )
-    ?getStatus@RTCRestClientResponseBase@@QAEHXZ                                ; (public: int __thiscall RTCRestClientResponseBase::getStatus(void))
+    ?getStatus@RTCRestClientResponseBase@@QBEHXZ                                ; (public: int __thiscall RTCRestClientResponseBase::getStatus(void)const )
     ?getString@RTCRestDate@@QBEABVRTCString@@XZ                                 ; (public: class RTCString const & __thiscall RTCRestDate::getString(void)const )
     ?getString@RTCRestStringEnumBase@@QBEPBDXZ                                  ; (public: char const * __thiscall RTCRestStringEnumBase::getString(void)const )
Index: trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc64.def
===================================================================
--- trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc64.def	(revision 74426)
+++ trunk/src/VBox/Runtime/VBox/VBoxRTImp-vcc64.def	(revision 74427)
@@ -326,8 +326,10 @@
     ?containsKey@RTCRestStringMapBase@@QEBA_NAEBVRTCString@@@Z                  ; (public: bool __cdecl RTCRestStringMapBase::containsKey(class RTCString const &)const )
     ?containsKey@RTCRestStringMapBase@@QEBA_NPEBD@Z                             ; (public: bool __cdecl RTCRestStringMapBase::containsKey(char const *)const )
-    ?copyArrayWorker@RTCRestArrayBase@@IEAAHAEBV1@_N@Z                          ; (protected: int __cdecl RTCRestArrayBase::copyArrayWorker(class RTCRestArrayBase const &,bool))
+    ?copyArrayWorkerMayThrow@RTCRestArrayBase@@IEAAXAEBV1@@Z                    ; (protected: void __cdecl RTCRestArrayBase::copyArrayWorkerMayThrow(class RTCRestArrayBase const &))
+    ?copyArrayWorkerNoThrow@RTCRestArrayBase@@IEAAHAEBV1@@Z                     ; (protected: int __cdecl RTCRestArrayBase::copyArrayWorkerNoThrow(class RTCRestArrayBase const &))
     ?copyErrInfo@RTCRestClientResponseBase@@IEAAXPEBURTERRINFO@@@Z              ; (protected: void __cdecl RTCRestClientResponseBase::copyErrInfo(struct RTERRINFO const *))
     ?copyFromN@RTCString@@IEAAXPEBD_K@Z                                         ; (protected: void __cdecl RTCString::copyFromN(char const *,unsigned __int64))
-    ?copyMapWorker@RTCRestStringMapBase@@IEAAHAEBV1@_N@Z                        ; (protected: int __cdecl RTCRestStringMapBase::copyMapWorker(class RTCRestStringMapBase const &,bool))
+    ?copyMapWorkerMayThrow@RTCRestStringMapBase@@IEAAXAEBV1@@Z                  ; (protected: void __cdecl RTCRestStringMapBase::copyMapWorkerMayThrow(class RTCRestStringMapBase const &))
+    ?copyMapWorkerNoThrow@RTCRestStringMapBase@@IEAAHAEBV1@@Z                   ; (protected: int __cdecl RTCRestStringMapBase::copyMapWorkerNoThrow(class RTCRestStringMapBase const &))
     ?count@RTCString@@QEBA_KD@Z                                                 ; (public: unsigned __int64 __cdecl RTCString::count(char)const )
     ?createInstance@RTCRestAnyObject@@SAPEAVRTCRestObjectBase@@XZ               ; (public: static class RTCRestObjectBase * __cdecl RTCRestAnyObject::createInstance(void))
@@ -426,10 +428,10 @@
     ?getExploded@RTCRestDate@@QEBAAEBURTTIME@@XZ                                ; (public: struct RTTIME const & __cdecl RTCRestDate::getExploded(void)const )
     ?getFormat@RTCRestDate@@QEBA?AW4kFormat@1@XZ                                ; (public: enum RTCRestDate::kFormat __cdecl RTCRestDate::getFormat(void)const )
-    ?getHttpStatus@RTCRestClientResponseBase@@QEAAHXZ                           ; (public: int __cdecl RTCRestClientResponseBase::getHttpStatus(void))
+    ?getHttpStatus@RTCRestClientResponseBase@@QEBAHXZ                           ; (public: int __cdecl RTCRestClientResponseBase::getHttpStatus(void)const )
     ?getPath@RTCRestJsonPrimaryCursor@@UEBAPEADAEBURTCRestJsonCursor@@PEAD_K@Z  ; (public: virtual char * __cdecl RTCRestJsonPrimaryCursor::getPath(struct RTCRestJsonCursor const &,char *,unsigned __int64)const )
     ?getPtr@RTCRestBinary@@QEBAPEBEXZ                                           ; (public: unsigned char const * __cdecl RTCRestBinary::getPtr(void)const )
     ?getServerUrl@RTCRestClientApiBase@@QEBAPEBDXZ                              ; (public: char const * __cdecl RTCRestClientApiBase::getServerUrl(void)const )
     ?getSize@RTCRestBinary@@QEBA_KXZ                                            ; (public: unsigned __int64 __cdecl RTCRestBinary::getSize(void)const )
-    ?getStatus@RTCRestClientResponseBase@@QEAAHXZ                               ; (public: int __cdecl RTCRestClientResponseBase::getStatus(void))
+    ?getStatus@RTCRestClientResponseBase@@QEBAHXZ                               ; (public: int __cdecl RTCRestClientResponseBase::getStatus(void)const )
     ?getString@RTCRestDate@@QEBAAEBVRTCString@@XZ                               ; (public: class RTCString const & __cdecl RTCRestDate::getString(void)const )
     ?getString@RTCRestStringEnumBase@@QEBAPEBDXZ                                ; (public: char const * __cdecl RTCRestStringEnumBase::getString(void)const )