Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.cpp	(revision 74444)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.cpp	(revision 74445)
@@ -45,5 +45,4 @@
         : m_enmProxyMode(KProxyMode_System)
         , m_strProxyHost(QString())
-        , m_strProxyPort(QString())
     {}
 
@@ -54,5 +53,4 @@
                && (m_enmProxyMode == other.m_enmProxyMode)
                && (m_strProxyHost == other.m_strProxyHost)
-               && (m_strProxyPort == other.m_strProxyPort)
                ;
     }
@@ -67,6 +65,4 @@
     /** Holds the proxy host. */
     QString     m_strProxyHost;
-    /** Holds the proxy port. */
-    QString     m_strProxyPort;
 };
 
@@ -99,15 +95,4 @@
     oldProxyData.m_enmProxyMode = m_properties.GetProxyMode();
     oldProxyData.m_strProxyHost = m_properties.GetProxyURL();
-    oldProxyData.m_strProxyPort = "";
-    if (!oldProxyData.m_strProxyHost.isEmpty())
-    {
-        QUrl url(oldProxyData.m_strProxyHost);
-        if (url.port() != -1)
-        {
-            oldProxyData.m_strProxyPort = QString::number(url.port());
-            url.setPort(-1);
-            oldProxyData.m_strProxyHost = url.url();
-        }
-    }
 
     /* Cache old proxy data: */
@@ -132,5 +117,4 @@
     }
     m_pHostEditor->setText(oldProxyData.m_strProxyHost);
-    m_pPortEditor->setText(oldProxyData.m_strProxyPort);
     sltHandleProxyToggle();
 
@@ -148,5 +132,4 @@
                                 : m_pRadioProxyDisabled->isChecked() ? KProxyMode_NoProxy : KProxyMode_System;
     newProxyData.m_strProxyHost = m_pHostEditor->text();
-    newProxyData.m_strProxyPort = m_pPortEditor->text();
 
     /* Cache new proxy data: */
@@ -182,12 +165,4 @@
     {
         message.second << tr("No proxy host is currently specified.");
-        fPass = false;
-    }
-
-    /* Check for port value: */
-    if (   m_pPortEditor->text().trimmed().isEmpty()
-        && QUrl(m_pHostEditor->text()).port() == -1)
-    {
-        message.second << tr("No proxy port is currently specified.");
         fPass = false;
     }
@@ -245,13 +220,4 @@
             connect(m_pHostEditor, SIGNAL(textEdited(const QString &)), this, SLOT(revalidate()));
         }
-
-        /* Port editor created in the .ui file. */
-        AssertPtrReturnVoid(m_pPortEditor);
-        {
-            /* Configure editor: */
-            m_pPortEditor->setFixedWidthByText(QString().fill('0', 6));
-            m_pPortEditor->setValidator(new QRegExpValidator(QRegExp("\\d+"), m_pPortEditor));
-            connect(m_pPortEditor, SIGNAL(textEdited(const QString &)), this, SLOT(revalidate()));
-        }
     }
 
@@ -282,13 +248,5 @@
         m_properties.SetProxyMode(newProxyData.m_enmProxyMode);
         fSuccess &= m_properties.isOk();
-        if (newProxyData.m_strProxyPort.isEmpty())
-            m_properties.SetProxyURL(newProxyData.m_strProxyHost);
-        else
-        {
-            QUrl url(newProxyData.m_strProxyHost);
-            if (url.port() == -1)
-                url.setPort(newProxyData.m_strProxyPort.toUInt());
-            m_properties.SetProxyURL(url.url());
-        }
+        m_properties.SetProxyURL(newProxyData.m_strProxyHost);
         fSuccess &= m_properties.isOk();
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.ui	(revision 74444)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsProxy.ui	(revision 74445)
@@ -80,5 +80,5 @@
        <widget class="QLabel" name="m_pHostLabel">
         <property name="text">
-         <string>Ho&amp;st:</string>
+         <string>&amp;URL:</string>
         </property>
         <property name="alignment">
@@ -94,24 +94,4 @@
         <property name="whatsThis">
          <string>Holds the proxy host.</string>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <widget class="QLabel" name="m_pPortLabel">
-        <property name="text">
-         <string>&amp;Port:</string>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy">
-         <cstring>m_pPortEditor</cstring>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <widget class="QILineEdit" name="m_pPortEditor">
-        <property name="whatsThis">
-         <string>Holds the proxy port.</string>
         </property>
        </widget>