Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 74466)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 74467)
@@ -38,4 +38,7 @@
 # include "COMEnums.h"
 # include "CMachine.h"
+
+/* Other VBox includes: */
+#include "iprt/cpp/utils.h"
 
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
@@ -245,10 +248,15 @@
 }
 
-void UIChooserItemMachine::paint(QPainter *pPainter, const QStyleOptionGraphicsItem *pOption, QWidget* /* pWidget = 0 */)
-{
-    /* Paint decorations: */
-    paintDecorations(pPainter, pOption);
+void UIChooserItemMachine::paint(QPainter *pPainter, const QStyleOptionGraphicsItem *pOptions, QWidget* /* pWidget = 0 */)
+{
+    /* Acquire rectangle: */
+    const QRect rectangle = pOptions->rect;
+
+    /* Paint background: */
+    paintBackground(pPainter, rectangle);
+    /* Paint frame: */
+    paintFrame(pPainter, rectangle);
     /* Paint machine info: */
-    paintMachineInfo(pPainter, pOption);
+    paintMachineInfo(pPainter, rectangle);
 }
 
@@ -883,16 +891,5 @@
 }
 
-void UIChooserItemMachine::paintDecorations(QPainter *pPainter, const QStyleOptionGraphicsItem *pOption)
-{
-    /* Prepare variables: */
-    const QRect fullRect = pOption->rect;
-
-    /* Paint background: */
-    paintBackground(pPainter, fullRect);
-    /* Paint frame: */
-    paintFrameRectangle(pPainter, fullRect);
-}
-
-void UIChooserItemMachine::paintBackground(QPainter *pPainter, const QRect &rect)
+void UIChooserItemMachine::paintBackground(QPainter *pPainter, const QRect &rectangle) const
 {
     /* Save painter: */
@@ -900,16 +897,16 @@
 
     /* Prepare color: */
-    QPalette pal = palette();
+    const QPalette pal = palette();
 
     /* Selection background: */
-    if (model()->currentItems().contains(this))
+    if (model()->currentItems().contains(unconst(this)))
     {
         /* Prepare color: */
-        QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
+        QColor backgroundColor = pal.color(QPalette::Active, QPalette::Highlight);
         /* Draw gradient: */
-        QLinearGradient bgGrad(rect.topLeft(), rect.bottomLeft());
-        bgGrad.setColorAt(0, highlight.lighter(m_iHighlightLightnessMax));
-        bgGrad.setColorAt(1, highlight.lighter(m_iHighlightLightnessMin));
-        pPainter->fillRect(rect, bgGrad);
+        QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessMax));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessMin));
+        pPainter->fillRect(rectangle, bgGrad);
     }
     /* Hovering background: */
@@ -917,10 +914,10 @@
     {
         /* Prepare color: */
-        QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
+        QColor backgroundColor = pal.color(QPalette::Active, QPalette::Highlight);
         /* Draw gradient: */
-        QLinearGradient bgGrad(rect.topLeft(), rect.bottomLeft());
-        bgGrad.setColorAt(0, highlight.lighter(m_iHoverLightnessMax));
-        bgGrad.setColorAt(1, highlight.lighter(m_iHoverLightnessMin));
-        pPainter->fillRect(rect, bgGrad);
+        QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessMax));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessMin));
+        pPainter->fillRect(rectangle, bgGrad);
     }
     /* Default background: */
@@ -928,10 +925,10 @@
     {
         /* Prepare color: */
-        QColor usual = pal.color(QPalette::Active, QPalette::Mid);
+        QColor backgroundColor = pal.color(QPalette::Active, QPalette::Mid);
         /* Draw gradient: */
-        QLinearGradient bgGrad(rect.topLeft(), rect.bottomLeft());
-        bgGrad.setColorAt(0, usual.lighter(m_iHoverLightnessMax));
-        bgGrad.setColorAt(1, usual.lighter(m_iHoverLightnessMin));
-        pPainter->fillRect(rect, bgGrad);
+        QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessMax));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessMin));
+        pPainter->fillRect(rectangle, bgGrad);
     }
 
@@ -940,8 +937,8 @@
     {
         /* Window color: */
-        QColor base = pal.color(QPalette::Active, model()->currentItems().contains(this) ?
+        QColor base = pal.color(QPalette::Active, model()->currentItems().contains(unconst(this)) ?
                                 QPalette::Highlight : QPalette::Window);
         QLinearGradient dragTokenGradient;
-        QRect dragTokenRect = rect;
+        QRect dragTokenRect = rectangle;
         if (dragTokenPlace() == DragToken_Up)
         {
@@ -965,5 +962,5 @@
 }
 
-void UIChooserItemMachine::paintFrameRectangle(QPainter *pPainter, const QRect &rect)
+void UIChooserItemMachine::paintFrame(QPainter *pPainter, const QRect &rectangle) const
 {
     /* Save painter: */
@@ -971,9 +968,9 @@
 
     /* Prepare color: */
-    QPalette pal = palette();
+    const QPalette pal = palette();
     QColor strokeColor;
 
     /* Selection frame: */
-    if (model()->currentItems().contains(this))
+    if (model()->currentItems().contains(unconst(this)))
         strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
     /* Hovering frame: */
@@ -990,7 +987,7 @@
 
     /* Draw borders: */
-    pPainter->drawLine(rect.topLeft(),    rect.topRight()    + QPoint(1, 0));
-    pPainter->drawLine(rect.bottomLeft(), rect.bottomRight() + QPoint(1, 0));
-    pPainter->drawLine(rect.topLeft(),    rect.bottomLeft());
+    pPainter->drawLine(rectangle.topLeft(),    rectangle.topRight()    + QPoint(1, 0));
+    pPainter->drawLine(rectangle.bottomLeft(), rectangle.bottomRight() + QPoint(1, 0));
+    pPainter->drawLine(rectangle.topLeft(),    rectangle.bottomLeft());
 
     /* Restore painter: */
@@ -998,9 +995,8 @@
 }
 
-void UIChooserItemMachine::paintMachineInfo(QPainter *pPainter, const QStyleOptionGraphicsItem *pOption)
+void UIChooserItemMachine::paintMachineInfo(QPainter *pPainter, const QRect &rectangle) const
 {
     /* Prepare variables: */
-    QRect fullRect = pOption->rect;
-    const int iFullHeight = fullRect.height();
+    const int iFullHeight = rectangle.height();
     const int iMargin = data(MachineItemData_Margin).toInt();
     const int iMajorSpacing = data(MachineItemData_MajorSpacing).toInt();
@@ -1010,5 +1006,5 @@
 
     /* Selected item foreground: */
-    if (model()->currentItems().contains(this))
+    if (model()->currentItems().contains(unconst(this)))
     {
         QPalette pal = palette();
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 74466)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 74467)
@@ -247,12 +247,10 @@
     /** @name Painting stuff.
       * @{ */
-        /** Paints decorations using specified @a pPainter and certain @a pOptions. */
-        void paintDecorations(QPainter *pPainter, const QStyleOptionGraphicsItem *pOption);
-        /** Paints background using specified @a pPainter and certain @a rect. */
-        void paintBackground(QPainter *pPainter, const QRect &rect);
-        /** Paints frame rectangle using specified @a pPainter and certain @a rect. */
-        void paintFrameRectangle(QPainter *pPainter, const QRect &rect);
-        /** Paints machine info using specified @a pPainter and certain @a pOptions. */
-        void paintMachineInfo(QPainter *pPainter, const QStyleOptionGraphicsItem *pOption);
+        /** Paints background using specified @a pPainter and certain @a rectangle. */
+        void paintBackground(QPainter *pPainter, const QRect &rectangle) const;
+        /** Paints frame using specified @a pPainter and certain @a rectangle. */
+        void paintFrame(QPainter *pPainter, const QRect &rectangle) const;
+        /** Paints machine info using specified @a pPainter and certain @a rectangle. */
+        void paintMachineInfo(QPainter *pPainter, const QRect &rectangle) const;
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 74466)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 74467)
@@ -403,7 +403,4 @@
 void UIToolsItem::paint(QPainter *pPainter, const QStyleOptionGraphicsItem *pOptions, QWidget * /* pWidget = 0 */)
 {
-    /* Setup: */
-    pPainter->setRenderHint(QPainter::Antialiasing);
-
     /* Acquire rectangle: */
     const QRect rectangle = pOptions->rect;
@@ -439,8 +436,8 @@
     m_iHoverLightnessMax = 120;
 #else /* VBOX_WS_MAC */
-    m_iHighlightLightnessMin = 120;
+    m_iHighlightLightnessMin = 130;
     m_iHighlightLightnessMax = 160;
-    m_iHoverLightnessMin = 155;
-    m_iHoverLightnessMax = 175;
+    m_iHoverLightnessMin = 160;
+    m_iHoverLightnessMax = 190;
 #endif /* !VBOX_WS_MAC */
 
@@ -753,11 +750,16 @@
     /* Selection frame: */
     if (model()->currentItem() == this)
-        strokeColor = pal.color(QPalette::Active, QPalette::Mid).darker(110);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
+    /* Hovering frame: */
+    else if (isHovered())
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessMin - 50);
     /* Default frame: */
     else
-        strokeColor = pal.color(QPalette::Active, QPalette::Midlight).darker(110);
-
-    /* Assign pen: */
-    pPainter->setPen(strokeColor);
+        strokeColor = pal.color(QPalette::Active, QPalette::Mid).lighter(m_iHoverLightnessMin);
+
+    /* Create/assign pen: */
+    QPen pen(strokeColor);
+    pen.setWidth(0);
+    pPainter->setPen(pen);
 
     /* Draw frame: */